#!/usr/bin/env php
<?php
//Load manifest file
$manifest = file_get_contents('../manifest.json');
$manifest = json_decode($manifest);

//List of files to add to the zip file
$filesList = array();

$filesList['..'.DIRECTORY_SEPARATOR.'pkg_speedcache.xml'] = 'pkg_speedcache.xml';
$filesList['..'.DIRECTORY_SEPARATOR.'install.php'] = 'install.php';

//List all packages folders to add it to the main package file
$folders = scandir('../packages');

//Loop over the folders
foreach($folders as $folder){
    $realFolder = '..'.DIRECTORY_SEPARATOR.'packages'.DIRECTORY_SEPARATOR.$folder;
    if(is_dir($realFolder) && $folder[0]!=='.'){
		$files = new RecursiveIteratorIterator(
			new RecursiveDirectoryIterator($realFolder),
			RecursiveIteratorIterator::LEAVES_ONLY
		);
		$rootPath = realpath($realFolder);

		foreach ($files as $name => $file){
			// Skip directories (they would be added automatically)
			if ($file->isDir()){
			    continue;
			}

			// Get real and relative path for current file
			$filePath = $file->getRealPath();
			$relativePath = substr($filePath, strlen($rootPath) + 1);

            $filesList[$filePath] = 'packages/'.$folder.'/'.$relativePath;
		}
    }
}

//Create zip package from files array
$zip = new ZipArchive();
if (!$zip->open('../../docker_host_files/root/pkg_speedcache.zip',ZipArchive::CREATE | ZipArchive::OVERWRITE)){
    die('ERROR CREATING ZIP PACKAGE');
}

foreach ($filesList as $filePath => $zipPath){
    //Replace version number in current file
    $content = file_get_contents($filePath);
    if(isset($manifest->version)){
        $content = str_replace("2.8.0",$manifest->version,$content);
    }

    // Add current file to archive
    $zip->addFromString($zipPath,$content);
}
$zip->close();