<?php
/**
 * Speedcache
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Speedcache
 * @copyright Copyright (C) 2016 JoomUnited (https://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


defined('_JEXEC') or die;

/**
 * speedcache Component speedcache
 *
 * @since  1.6
 */
class speedcacheControllerCdns extends JControllerForm
{
    /**
     * Method (override) to check if you can save a new or existing record.
     *
     * Adjusts for the primary key name and hands off to the parent class.
     *
     * @param   array $data An array of input data.
     * @param   string $key The name of the key for the primary key.
     *
     * @return  boolean
     *
     * @since   1.6
     */
    protected function allowSave($data, $key = 'id')
    {
        return parent::allowSave($data, $key);
    }

    public function save($key = null, $cdn = null)
    {
        //Security check
        JSession::checkToken() or die('Invalid Token');

        $input = JFactory::getApplication()->input;
        // If we are on the save command we need the actual data
        $jformData = $input->get('jform', array(), 'array');

        if (empty($jformData)) {
            $this->messageRedirect('error');
            return false;
        }

        $model = $this->getModel();
        $global = $model->saveCDNGlobalConfig($jformData);

        if (!$global) {
            $this->messageRedirect('error');
            return false;
        }

        $this->messageRedirect('success');
        return true;
    }

    public function messageRedirect($type)
    {
        $message = JText::_('COM_SPEEDCACHE_CONFIG_CDN_ERROR_MESSAGE');
        if ($type === 'success') {
            $message = JText::_('COM_SPEEDCACHE_CONFIG_CDN_SUCCESS_MESSAGE');
        }

        JFactory::getSession()->set(
            'speedache_cdn_page_message',
            array(
                'type' => $type,
                'text' => $message
            )
        );
        $this->setRedirect(JRoute::_('index.php?option=' . $this->option . '&view=' . $this->view_list .$this->getRedirectToListAppend(), false));
    }
}
