<?php

defined('_JEXEC') or die;

/**
 * Model for component configuration
 *
 * @since  3.2
 */
class speedcacheModelCdns extends JModelAdmin
{
    /**
     * Method to get form file config
     *
     * @param array $data File data
     * @param boolean $loadData Load data
     *
     * @return boolean
     * @since  version
     */
    public function getForm($data = array(), $loadData = true)
    {
        // Add the search path for the admin component config.xml file.
        JForm::addFormPath(JPATH_ADMINISTRATOR . '/components/com_speedcache');

        $form = $this->loadForm('com_speedcache.config', 'config', array('control' => 'jform', 'load_data' => $loadData), false, '/config');

        if (empty($form)) {
            return false;
        }

        return $form;
    }

    public function saveCDNGlobalConfig($jformData)
    {
        //Load the data form
        $form = $this->getForm();

        $default_parameter = array();
        foreach ($form->getFieldsets() as $name => $fieldsets) {
            foreach ($form->getFieldset($name) as $fieldset) {
                if ($fieldset->type === 'Radio') {
                    $fieldset->value = 0;
                }
                $default_parameter[$fieldset->fieldname] = $fieldset->value;
            }
        }

        $new_parameter = array_replace($default_parameter, $jformData);


        //Set configuration
        if (!speedcacheComponentHelper::setParams($new_parameter)) {
            return false;
        }

        return true;
    }
}
