<?php
/**
 * Speedcache
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Speedcache
 * @copyright Copyright (C) 2016 JoomUnited (https://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') or die;

/**
 * HTML View class for the speedcache component
 *
 * @since  1.6
 */
class speedcacheViewCdns extends JViewLegacy
{
    protected $formField;
    protected $params;

    /**
     * Execute and display a template script.
     *
     * @param   string $tpl The name of the template file to parse; automatically searches through the template paths.
     *
     * @return  mixed  A string if successful, otherwise a Error object.
     *
     * @since   1.6
     */
    public function display($tpl = null)
    {
        JHtml::_('jquery.framework');

        $document = JFactory::getApplication()->getDocument();
        $document->addStyleSheet(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/css/jquery.qtip.css');
        // Load script
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/velocity.min.js');
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/script.js');
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/waves.min.js');
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/jquery.qtip.min.js');

        $model = $this->getModel();
        //Load the data form
        $form = $model->getForm();
        $data = JComponentHelper::getParams('com_speedcache');

        // Bind data
        if ($form && $data) {
            $form->bind($data);
        }

        $this->formField = $form->getFieldset('cdn_config');
        $this->params = &$data;

        $this->addToolbar();
        parent::display($tpl);
    }

    /**
     * Add the page title and toolbar.
     *
     * @return  void
     *
     * @since   1.6
     */
    protected function addToolbar()
    {
        $canDo = JHelperContent::getActions('com_speedcache');
        $bar = JToolbar::getInstance('toolbar');
        JToolbarHelper::title('SpeedCache : ' . JText::_('COM_SPEEDCACHE_CONFIG_CDN_DESC'));

        if ($canDo->get('core.edit.state')) {
            JFactory::getApplication()->input->set('hidemainmenu', true);
            JToolbarHelper::apply('cdns.save');
        }

        if ($canDo->get('core.admin')) {
            JToolbarHelper::divider();

            $bohtml = "<button class='ju-button orange-outline-button orange-border waves-effect waves-light' onclick='Joomla.submitbutton(\"urls.redirectConfiguration\");'>
			<span class='material-icons'>settings</span> " . JText::_('COM_SPEEDCACHE_BTN_BACK_OPTIONS') . "</button>";
            $bar->appendButton('Custom', $bohtml, "speedcachebackoptions");

            $bdhtml = "<button class='ju-button orange-button waves-effect waves-light' onclick='Joomla.submitbutton(\"dashboard\");'>
			<span class='material-icons'>dashboard</span> " . JText::_('COM_SPEEDCACHE_BTN_BACK_DASHBOARD') . "</button>";
            $bar->appendButton('Custom', $bdhtml, "speedcachebackdashboard");

        }
    }
}
