<?php
defined('_JEXEC') or die;

$settings = array(
    'parameters' => array(
        'nav_name' => JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_NAV_NAME_PARAMETERS'),
        'icon' => 'settings'
    ),
    'minify' => array(
        'nav_name' => JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_NAV_NAME_MINIFY_GROUP'),
        'icon' => 'group_work'
    ),
    'default_values' => array(
        'nav_name' => JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_NAV_NAME_DEFAULT_VALUES'),
        'icon' => 'done_all'
    ),
    'cdn' => array(
        'nav_name' => JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_NAV_NAME_CDN'),
        'icon' => 'public'
    ),
    'imagerecycle' => array(
        'nav_name' => JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_NAV_NAME_IMAGERECYCLE'),
        'icon' => 'compare'
    ),
    'import_export' => array(
        'nav_name' => JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_NAV_NAME_IMPORT_EXPORT'),
        'icon' => 'import_export'
    ),
    'permissions' => array(
        'nav_name' => JText::sprintf('JCONFIG_PERMISSIONS_LABEL'),
        'icon' => 'group'
    ),
    'live_updates' => array(
        'nav_name' => JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_NAV_NAME_LIVE_UPDATES'),
        'icon' => 'update'
    ),
    'translations' => array(
        'nav_name' => JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_NAV_NAME_TRANSLATIONS'),
        'icon' => 'text_format'
    )
);

JHtml::_('behavior.formvalidator');
JFactory::getDocument()->addScriptDeclaration("
    Joomla.submitbutton = function(task)
    {
        if (task == 'wizard.cancel' || document.formvalidator.isValid(document.getElementById('configuration-form')))
        {
            Joomla.submitform(task, document.getElementById('configuration-form'));
        }
    };
");
?>

<form id="configuration-form" method="POST" action="<?php echo JRoute::_('index.php?option=com_speedcache&view=configuration'); ?>">
    <div class="ju-main-wrapper">
        <div class="ju-left-panel-toggle">
            <i class="material-icons ju-left-panel-toggle-icon" style="font-size: 20px">code</i>
        </div>
        <div class="ju-left-panel">
            <div class="ju-logo">
                <a href="https://www.joomunited.com/products/speed-cache" target="_blank">
                    <p><?php echo JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_LEFT_LOGO') ?></p>
                    <img src="<?php echo JUri::root(true) . '/administrator/components/com_speedcache/assets/joomla-css-framework/images/Logo-JoomUnited-settings.png' ?>"
                         srcset="<?php echo JUri::root(true) . '/administrator/components/com_speedcache/assets/joomla-css-framework/images/Logo-JoomUnited-settings.png' ?>"
                         alt="<?php echo JText::sprintf('COM_SPEEDCACHE_CONFIGURATION_JU_LOGO') ?>">
                </a>
            </div>
            <div class="ju-menu-search">
                <i class="material-icons mi mi-search ju-menu-search-icon">search</i>
                <input type="text" class="ju-menu-search-input" size="16" placeholder="Search settings">
            </div>
            <ul class="tabs ju-menu-tabs">
                <?php foreach ($settings as $k => $v) : ?>
                    <li class="tab" data-tab-title="<?php echo $v['nav_name'] ?>">
                        <a href="#<?php echo $k; ?>" class="link-tab white-text waves-effect waves-light">
                            <i class="material-icons mi menu-tab-icon"><?php echo $v['icon']; ?></i>
                            <span class="name tab-title"><?php echo $v['nav_name']; ?></span>
                        </a>
                    </li>
                <?php endforeach; ?>
            </ul>
        </div>
        <div class="ju-right-panel">
            <?php
            if ($message = JFactory::getSession()->get('sc_configuration_message')) :
                JFactory::getSession()->clear('sc_configuration_message');
            ?>
            <div id="ju-message-container">
                <div class="alert alert-<?php echo $message['type'] ?>">
                    <button type="button" class="close" data-dismiss="alert">×</button>
                    <h4 class="alert-heading">Message</h4>
                    <div class="alert-message"><?php echo JText::sprintf($message['text']); ?></div>
                </div>
            </div>
            <?php endif; ?>
            <?php foreach ($settings as $k => $v) :?>
                <div class="ju-content-wrapper" id="<?php echo ($k); ?>" style="display: none">
                    <?php echo $this->loadTemplate($k); ?>
                </div>
            <?php endforeach; ?>
        </div>
        <div class="clear"></div>
    </div>
    <input type="hidden" name="task" value=""/>
    <input type="hidden" name="jform[component]" value="com_speedcache" />
    <?php echo JHtml::_('form.token'); ?>
</form>

