<?php
/**
 * Speedcache
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Speedcache
 * @copyright Copyright (C) 2016 JoomUnited (https://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') or die;

/**
 * HTML View class for the speedcache component
 *
 * @since  1.6
 */
class speedcacheViewConfiguration extends JViewLegacy
{
    protected $params;
    protected $form;
    /**
     * Execute and display a template script.
     *
     * @param string $tpl The name of the template file to parse; automatically searches through the template paths.
     *
     * @return  mixed  A string if successful, otherwise a Error object.
     *
     * @since   1.6
     */
    public function display($tpl = null)
    {
        JHtml::_('jquery.framework');
        JHtml::_('script', 'jui/cms.js', array('version' => 'auto', 'relative' => true));

        $document = JFactory::getApplication()->getDocument();
        // Load style
        $document->addStyleSheet('https://fonts.googleapis.com/icon?family=Material+Icons|Nunito+Sans|Nunito+Sans:Bold|Nunito+Sans:SemiBold');
        $document->addStyleSheet(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/css/style.min.css');
        $document->addStyleSheet(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/css/waves.min.css');
        $document->addStyleSheet(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/css/jquery.qtip.css');
        $document->addStyleSheet(JUri::base() . 'components/com_speedcache/assets/css/configuration.min.css');
        // Load script
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/velocity.min.js');
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/tabs.js');
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/script.js');
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/waves.min.js');
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/joomla-css-framework/js/jquery.qtip.min.js');
        $document->addScript(JUri::base() . 'components/com_speedcache/assets/js/configuration.js');

        $model = $this->getModel();
        //Load the data form
        $form = $model->getForm();
        $data = JComponentHelper::getParams('com_speedcache');

        // Bind data
        if ($form && $data)
        {
            $form->bind($data);
        }

        $this->form = &$form;
        $this->params = &$data;

        $this->addToolbar();
        parent::display($tpl);

    }

    /**
     * Add the page title and toolbar.
     *
     * @return  void
     *
     * @since   1.6
     */
    protected function addToolbar()
    {
        JToolbarHelper::title(JText::_('COM_SPEEDCACHE_CONFIGURATION_TITLE'));

        // Generate html for toolbar button
        $html = array();
        $html[] = '<button onclick="Joomla.submitbutton(\'configuration.save_params\');"  class="ju-button orange-button waves-effect waves-light">';
        $html[] = '<span class="icon-apply ju-icon orange-icon" aria-hidden="true"></span>' . JText::_('COM_SPEEDCACHE_CONFIGURATION_SAVE_BUTTON_NAME');
        $html[] = '</button>';
        $html[] = '<button onclick="Joomla.submitbutton(\'configuration.save_params_and_close\');"  class="ju-button orange-outline-button orange-border waves-effect waves-light">';
        $html[] = '<span class="icon-save ju-icon orange-outline-icon" aria-hidden="true"></span>' . JText::_('COM_SPEEDCACHE_CONFIGURATION_SAVE_AND_CLOSE_BUTTON_NAME');
        $html[] = '</button>';
        $html[] = '<button onclick="Joomla.submitbutton(\'configuration.close_configuration\');"  class="ju-button black-outline-button waves-effect waves-light">';
        $html[] = '<span class="icon-cancel ju-icon black-outline-icon" aria-hidden="true"></span>' . JText::_('COM_SPEEDCACHE_CONFIGURATION_CANCEL_BUTTON_NAME');
        $html[] = '</button>';
        $toolbar = JToolBar::getInstance('toolbar');
        $toolbar->appendButton('Custom', implode('', $html));

    }
}
