<?php
/**
 * Speedcache
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Speedcache
 * @copyright Copyright (C) 2016 JoomUnited (https://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') or die;

/**
 * HTML View class for the speedcache component
 *
 * @since  1.6
 */
class speedcacheViewDashboard extends JViewLegacy
{
    protected $checkMinify = false;
    /**
     * Execute and display a template script.
     *
     * @param   string $tpl The name of the template file to parse; automatically searches through the template paths.
     *
     * @return  mixed  A string if successful, otherwise a Error object.
     *
     * @since   1.6
     */
    public function display($tpl = null)
    {
        JHtml::_('jquery.framework');
        $document = JFactory::getApplication()->getDocument();
        $document->addStyleSheet(JUri::base() . 'components/com_speedcache/assets/css/dashboard.min.css');

        $params = JComponentHelper::getParams('com_speedcache');
        $model = $this->getModel();

        $this->urlsCount = $model->countUrls();
        $fileminify = $model->checkMinifyOnDashBoard();
        $htmlminify = $params->get('minify_html', 1);

        if ($htmlminify || $fileminify) {
            $this->checkMinify = true;
        }
        parent::display($tpl);

        $this->addToolbar();
    }

    /**
     * Add the page title and toolbar.
     *
     * @return  void
     *
     * @since   1.6
     */
    protected function addToolbar()
    {
        JToolbarHelper::title('SpeedCache : ' . JText::_('COM_SPEEDCACHE_DASHBOARD'));
    }
}
