<?php
/**
 * Speedcache
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Speedcache
 * @copyright Copyright (C) 2016 JoomUnited (https://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') or die;

$user = JFactory::getUser();
$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn = $this->escape($this->state->get('list.direction'));
?>
<script>
    jQuery('document').ready(function ($) {
        //        scan
        $('#scan-asset').click(function () {
            $.ajax({
                url: 'index.php?option=com_speedcache&view=minifications&task=minifications.getAllowedPath',
                method: 'POST',
                success: function (path) {
                    var path = $.parseJSON(path);
                    if (path.status) {
                        alert('Error scan!');
                        window.location.reload(true);
                    }
                    var i = 0;
                    var scan = function (dir, path) {
                        $.ajax({
                            url: 'index.php?option=com_speedcache&view=minifications&task=minifications.getFileAssets',
                            method: 'POST',
                            data: {
                                dir: dir
                            },
                            success: function (res) {
                                i++;
                                if (i < path.length) {
                                    scan(path[i], path);
                                } else {
                                    window.location.reload(true);
                                }

                            }
                        });
                    };
                    scan(path[i], path);
                }
            });
        });

        //change minify state
        $('.speedcache-optimization').change(function () {
            var minify = $(this).val();
            var id = $(this).data("id");
            $.ajax({
                url: 'index.php?option=com_speedcache&view=minifications&task=minifications.changeMinify',
                method: 'POST',
                data: {
                    minify: minify,
                    id: id
                }, success: function () {
                    window.location.reload(true);
                }
            });
        });

        //minify all
        $('#toggle-state').click(function () {
            var ids = [];
            $('input[type=checkbox]:checked').each(function () {
                ids.push($(this).val());
            });
            $.ajax({
                url: 'index.php?option=com_speedcache&view=minifications&'+
                'task=minifications.activeAll&<?php echo JSession::getFormToken(); ?>=1',
                method: 'POST',
                data: {
                    ids: ids
                },
                success: function (res) {
                    window.location.reload(true);
                }
            });
        });

        //Change state group
        $('.group-minify-field').click(function () {
            var state = $(this).val();
            var type = $(this).attr('name');

            $.ajax({
                url: 'index.php?option=com_speedcache&view=minifications&'+
                'task=minifications.changeStateGroup&<?php echo JSession::getFormToken(); ?>=1',
                method: 'POST',
                data: {
                    state: state,
                    type: type
                },
                success: function (res) {
                    window.location.reload(true);
                }
            });
        });

        $('input[name=filter_type]').change(function () {
            var id = $(this).attr('id');
            $('#filter-switch-minifications').find('label').removeClass();
            if (id == 'all') {
                $("[for=all]").addClass('all');
            }
            if (id == 'sc-js-minifications') {
                $("[for=sc-js-minifications]").addClass('sc-js-minifications');
            }
            if (id == 'sc-css-minifications') {
                $("[for=sc-css-minifications]").addClass('sc-css-minifications');
            }
            if (id == 'sc-font-minifications') {
                $("[for=sc-font-minifications]").addClass('sc-font-minifications');
            }

            this.form.submit();
        });

        var filterselected = $('input[name=filter_type]:checked').val();
        if (filterselected == '2') {
            $("[for=sc-js-minifications]").addClass('sc-js-minifications');
        } else if (filterselected == '1') {
            $("[for=sc-css-minifications]").addClass('sc-css-minifications');
        } else if (filterselected == '0') {
            $("[for=sc-font-minifications]").addClass('sc-font-minifications');
        } else {
            $("[for=all]").addClass('all');
        }
    });

</script>


<?php
$session = JFactory::getSession();
$message = $session->get('speedache_message');
$session->clear('speedache_message');
if ($message) :
    ?>
    <div class="alert alert-success">
        <div class="alert-message"><?php echo $message['message']; ?></div>
    </div>
<?php endif; ?>

<form action="<?php echo JRoute::_('index.php?option=com_speedcache&view=minifications'); ?>" method="post"
      name="adminForm" id="adminForm" class="minify-group-form">

    <div id="j-main-container" class="sc-minifications-form">
        <div id="page-description" class="page-description">
            <p><?php echo JText::_('COM_SPEEDCACHE_CONFIG_MINIFICATIONS_INTRODUCTION_FIRST') ?></p>
            <p><?php echo JText::_('COM_SPEEDCACHE_CONFIG_MINIFICATIONS_INTRODUCTION_SECOND') ?>
                <a href="https://www.joomunited.com/documentation/speed-cache-documentation" target="_blank">
                    <?php echo JText::_('COM_SPEEDCACHE_CONFIG_MINIFICATIONS_INTRODUCTION_THIRD') ?>
                </a>
            </p>
        </div>
        <div id="groupFileField" class="minify-group-field">
            <ul class="field block-list">
                <li class="ju-settings-option block-item">
                    <label for="html-minify" class="ju-setting-label speedcache-tooltip" alt="<?php echo JText::_('COM_SPEEDCACHE_CONFIG_MINIFY_HTML_DESC'); ?>">
                        <?php echo JText::_('COM_SPEEDCACHE_CONFIG_MINIFY_HTML_LABEL') ?>
                    </label>
                    <div class="ju-switch-button">
                        <label class="switch">
                            <input type="checkbox" class="group-minify-field" name="minify_html" id="html-minify"
                                <?php echo ($this->minifyHTML == '1') ? 'checked="checked"' : '' ?>
                                   value="<?php echo $this->minifyHTML; ?>" />
                            <span class="slider"></span>
                        </label>
                    </div>
                </li>
                <li class="ju-settings-option block-item">
                    <label for="grcss-minify" class="ju-setting-label speedcache-tooltip" alt="<?php echo JText::_('COM_SPEEDCACHE_CONFIG_GROUP_CSS_DESC'); ?>">
                        <?php echo JText::_('COM_SPEEDCACHE_GROUP_MINIFICATIONS_CSS') ?>
                    </label>
                    <div class="ju-switch-button">
                        <label class="switch">
                            <input type="checkbox" class="group-minify-field" name="minify_group_css" id="grcss-minify"
                                <?php echo ($this->groupCss == '1') ? 'checked="checked"' : '' ?>
                                   value="<?php echo $this->groupCss; ?>" />
                            <span class="slider"></span>
                        </label>
                    </div>
                </li>
                <li class="ju-settings-option block-item">
                    <label for="grjs-inhead-minify" class="ju-setting-label speedcache-tooltip" alt="<?php echo JText::_('COM_SPEEDCACHE_CONFIG_GROUP_JS_INHEAD_DESC'); ?>">
                        <?php echo JText::_('COM_SPEEDCACHE_CONFIG_GROUP_JS_INHEAD_LABEL') ?>
                    </label>
                    <div class="ju-switch-button">
                        <label class="switch">
                            <input type="checkbox" class="group-minify-field" name="minify_group_js_inhead" id="grjs-inhead-minify"
                                <?php echo ($this->groupJSInHead == '1') ? 'checked="checked"' : '' ?>
                                   value="<?php echo $this->groupJSInHead; ?>" />
                            <span class="slider"></span>
                        </label>
                    </div>
                </li>
                <li class="ju-settings-option block-item">
                    <label for="grjs-minify" class="ju-setting-label speedcache-tooltip" alt="<?php echo JText::_('COM_SPEEDCACHE_CONFIG_GROUP_JS_DESC'); ?>">
                        <?php echo JText::_('COM_SPEEDCACHE_GROUP_MINIFICATIONS_JS') ?>
                    </label>
                    <div class="ju-switch-button">
                        <label class="switch">
                            <input type="checkbox" class="group-minify-field" name="minify_group_js" id="grjs-minify"
                                <?php echo ($this->groupJS == '1') ? 'checked="checked"' : '' ?>
                                   value="<?php echo $this->groupJS; ?>" />
                            <span class="slider"></span>
                        </label>
                    </div>
                </li>
                <li class="ju-settings-option block-item">
                    <label for="grfont-minify" class="ju-setting-label speedcache-tooltip" alt="<?php echo JText::_('COM_SPEEDCACHE_CONFIG_GROUP_FONT_DESC'); ?>">
                        <?php echo JText::_('COM_SPEEDCACHE_GROUP_MINIFICATIONS_FONT') ?>
                    </label>
                    <div class="ju-switch-button">
                        <label class="switch">
                            <input type="checkbox" class="group-minify-field" name="minify_group_fonts" id="grfont-minify"
                                <?php echo ($this->groupFont == '1') ? 'checked="checked"' : '' ?>
                                   value="<?php echo $this->groupFont; ?>" />
                            <span class="slider"></span>
                        </label>
                    </div>
                </li>
                <li class="ju-settings-option block-item">
                    <label for="defer-css" class="ju-setting-label speedcache-tooltip" alt="<?php echo JText::_('COM_SPEEDCACHE_CONFIG_DEFER_CSS_DESC'); ?>">
                        <?php echo JText::_('COM_SPEEDCACHE_CONFIG_DEFER_CSS_LABEL') ?>
                    </label>
                    <div class="ju-switch-button">
                        <label class="switch">
                            <input type="checkbox" class="group-minify-field" name="defer_css" id="defer-css"
                                <?php echo ($this->deferCSS == '1') ? 'checked="checked"' : '' ?>
                                   value="<?php echo $this->deferCSS; ?>" />
                            <span class="slider"></span>
                        </label>
                    </div>
                </li>
                <li class="ju-settings-option block-item">
                    <label for="defer-js" class="ju-setting-label speedcache-tooltip" alt="<?php echo JText::_('COM_SPEEDCACHE_CONFIG_DEFER_JS_DESC'); ?>">
                        <?php echo JText::_('COM_SPEEDCACHE_CONFIG_DEFER_JS_LABEL') ?>
                    </label>
                    <div class="ju-switch-button">
                        <label class="switch">
                            <input type="checkbox" class="group-minify-field" name="defer_js" id="defer-js"
                                <?php echo ($this->deferJS == '1') ? 'checked="checked"' : '' ?>
                                   value="<?php echo $this->deferJS; ?>" />
                            <span class="slider"></span>
                        </label>
                    </div>
                </li>
                <li class="ju-settings-option block-item">
                    <label for="exclude-inline-script" class="ju-setting-label speedcache-tooltip" alt="<?php echo JText::_('COM_SPEEDCACHE_CONFIG_EXCLUDE_INLINE_SCRIPT_DESC'); ?>">
                        <?php echo JText::_('COM_SPEEDCACHE_CONFIG_EXCLUDE_INLINE_SCRIPT_LABEL') ?>
                    </label>
                    <div class="ju-switch-button">
                        <label class="switch">
                            <input type="checkbox" class="group-minify-field" name="exclude_inline_script" id="exclude-inline-script"
                                <?php echo (isset($this->excludeInlineScript) && $this->excludeInlineScript == '1') ? 'checked="checked"' : '' ?>
                                   value="<?php echo (isset($this->excludeInlineScript) ? $this->excludeInlineScript : 0) ?>" />
                            <span class="slider"></span>
                        </label>
                    </div>
                </li>
            </ul>
        </div>
        <br>
        <div id="filter-switch-minifications" class="minifications-switch-tab">
            <div class="switch-toggle pull-left">
                <?php
                $checked = ($this->state->get('filter.type') == "") ? "checked='checked'" : ""; ?>
                <input id="all" name="filter_type" type="radio" <?php echo $checked; ?> value=''>
                <label for="all">All</label>

                <?php $checked = ($this->state->get('filter.type') == "2") ? "checked='checked'" : ""; ?>
                <input id="sc-js-minifications" name="filter_type" type="radio"
                       value="2" <?php echo $checked; ?>>
                <label for="sc-js-minifications">
                    <?php echo JText::_('COM_SPEEDCACHE_MINIFICATIONS_JAVASCRIPT') ?>
                </label>

                <?php $checked = ($this->state->get('filter.type') == "1") ? "checked='checked'" : ""; ?>
                <input id="sc-css-minifications" name="filter_type" type="radio"
                       value="1" <?php echo $checked; ?>>
                <label for="sc-css-minifications">
                    <?php echo JText::_('COM_SPEEDCACHE_MINIFICATIONS_CSS') ?>
                </label>

                <?php $checked = ($this->state->get('filter.type') == "0") ? "checked='checked'" : ""; ?>
                <input id="sc-font-minifications" name="filter_type" type="radio"
                       value="0" <?php echo $checked; ?>>
                <label for="sc-font-minifications">
                    <?php echo JText::_('COM_SPEEDCACHE_MINIFICATIONS_FONT') ?>
                </label>

                <a class="btn btn-primary"></a>
            </div>
        </div>
        <div class="scan-minifications pull-right">
            <a class="material-button" id="toggle-state" href="#">
                <i class="material-icons">check</i><?php echo JText::_('COM_SPEEDCACHE_MINIFICATION_TOGGLE_STATE'); ?>
            </a>
            <a class="material-button" id="scan-asset" href="#">
                <i class="material-icons">cached</i><?php echo JText::_('COM_SPEEDCACHE_MINIFICATION_SCAN'); ?>
            </a>
        </div>

        <div class="filter-minify-search pull-right">
            <input type="text" name="filter_search" id="filter_search"
                   placeholder="<?php echo JText::_('COM_SPEEDCACHE_MINIFICATIONS_JSEARCH_FILTER'); ?>"
                   value="<?php echo $this->escape($this->state->get('filter.search')); ?>" class="hasTooltip"
                   title="<?php echo JHtml::tooltipText('COM_SPEEDCACHE_MINIFICATIONS_JSEARCH_FILTER_TOOLTIP'); ?>"/>
        </div>
        <div class="clearfix"></div>
        <br>
        <?php if (empty($this->items)) : ?>
            <div class="alert alert-no-items">
                <?php echo JText::_('JGLOBAL_NO_MATCHING_RESULTS'); ?>
            </div>
        <?php else: ?>
            <div class="form-horizontal jsc-minifications-table">
                <table class="table table-striped">
                    <thead>
                    <tr>
                        <th width="2%" class="center">
                            <?php echo JHtml::_(
                                'grid.checkall',
                                'checkall-toggle',
                                'JGLOBAL_CHECK_ALL',
                                'joomla_sc.checkAll(this)'
                            ); ?>
                        </th>
                        <th width="5%" class="left">
                            <?php echo JHtml::_(
                                'grid.sort',
                                JText::_('COM_SPEEDCACHE_MINIFICATION_TYPE'),
                                'a.type',
                                $listDirn,
                                $listOrder
                            ); ?>
                        </th>
                        <th class="left">
                            <?php echo JHtml::_(
                                'grid.sort',
                                JText::_('COM_SPEEDCACHE_MINIFICATION_FILE'),
                                'a.file',
                                $listDirn,
                                $listOrder
                            ); ?>
                        </th>
                        <th width="12%" class="center">
                            <?php echo JHtml::_(
                                'grid.sort',
                                JText::_('COM_SPEEDCACHE_MINIFICATION_MINIFY'),
                                'a.minify',
                                $listDirn,
                                $listOrder
                            ); ?>
                        </th>
                    </tr>
                    </thead>
                    <tfoot>
                        <tr>
                            <td colspan="3">
                                <?php echo $this->pagination->getListFooter(); ?>
                            </td>
                            <td>
                                <div class="display-limit pull-right">
                                    <?php echo JText::_('JGLOBAL_DISPLAY_NUM'); ?>&#160;
                                    <?php echo $this->pagination->getLimitBox(); ?>
                                </div>
                            </td>
                        </tr>
                    </tfoot>
                    <tbody>
                    <?php foreach ($this->items as $i => $item) :
                        ?>
                        <tr class="row<?php echo $i % 2; ?>">
                            <td class="center">
                                <?php echo JHtml::_('grid.id', $i, $item->id); ?>
                            </td>
                            <td>
                                <?php
                                if ($item->type == 0) {
                                    $type = 'FONT';
                                } elseif ($item->type == 1) {
                                    $type = 'CSS';
                                } else {
                                    $type = 'JS';
                                }
                                ?>
                                <span class="sc-filename-extension sc-filename-extension-<?php
                                echo strtolower($type); ?>">
                                    <?php echo JText::_('COM_SPEEDCACHE_MINIFICATION_' . $type); ?></span>
                            </td>
                            <td class="file-tab">
                                <span class="file"><?php echo $this->escape($item->file); ?></span>
                            </td>
                            <td class="center">
                                <div class="ju-switch-button">
                                    <label class="switch">
                                        <input type="checkbox" data-id='<?php echo $item->id; ?>'
                                               class="speedcache-optimization" name="active-minify" id="active-minify-<?php echo $item->id; ?>"
                                            <?php echo ($item->minify) ? 'checked="checked"' : '' ?>
                                               value="<?php echo $item->minify; ?>" />
                                        <span class="slider"></span>
                                    </label>
                                </div>
                            </td>
                        </tr>
                        <?php
                    endforeach; ?>
                    </tbody>
                </table>
            </div>
        <?php endif; ?>
        <input type="hidden" name="task" value=""/>
        <input type="hidden" name="boxchecked" value="0"/>
        <input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>"/>
        <input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>"/>
        <?php echo JHtml::_('form.token'); ?>
    </div>
</form>
