<?php
/**
 * Speedcache
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Speedcache
 * @copyright Copyright (C) 2016 JoomUnited (https://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') or die;

JFactory::getDocument()->addScriptDeclaration("
		Joomla.submitbutton = function(task)
		{
			if (task == 'url.cancel' || document.formvalidator.isValid(document.getElementById('speedcache-form')))
			{
				Joomla.submitform(task, document.getElementById('speedcache-form'));
			}
		};
");

$list_items = array('url', 'excludeguest', 'excludelogged');
?>
<form action="<?php echo JRoute::_('index.php?option=com_speedcache&layout=edit&id=' . (int)$this->item->id); ?>"
      method="post" name="adminForm" id="speedcache-form" class="form-validate form-horizontal sc-url-form">
    <fieldset>
        <ul class="field block-list">
            <?php foreach ($list_items as $v) :
                $field = $this->form->getField($v);
                ?>
                <li class="ju-settings-option block-item">
                    <label for="<?php echo $field->id ?>" class="ju-setting-label speedcache-tooltip"
                           alt="<?php echo JText::sprintf($field->description) ?>"><?php echo strip_tags($field->label) ?></label>
                    <?php
                    switch ($field->type) {
                        case 'Radio' :
                            $checked = ($this->item->$v) ? 'checked="checked"' : '';
                            echo '<div class="ju-switch-button">
                                    <label class="switch">
                                        <input type="checkbox" '.$checked.' name="' . $field->name . '" id="' . $field->id . '" value="1">
                                        <span class="slider"></span>
                                    </label>
                                </div>';
                            break;
                        default :
                            $first_text = ($v === 'url') ? Juri::root() : '';
                            $text_class = ($field->type === 'Text') ? ' ju-custom-right-side' : '';
                            $select_class = ($field->type === 'List') ? ' ju-custom-select ju-custom-right-side' : '';
                            echo '<div class="ju-custom-block ' . $text_class . $select_class . '" >';
                            echo $first_text . $field->input;
                            echo '</div>';
                            break;
                    }
                    ?>
                </li>
            <?php endforeach; ?>
        </ul>
        <?php echo $this->form->getInput('type'); ?>
        <?php echo $this->form->getInput('id'); ?>
    </fieldset>
    <input type="hidden" name="task" value=""/>
    <?php echo JHtml::_('form.token'); ?>
</form>
