<?php
defined('_JEXEC') or die;

$gif_image = '<img class="ju-settings-icon wz-loading-icon" src="' . JURI::root() . 'administrator/components/com_speedcache/assets/images/loading.gif" />';
$icon = array(
    'ok' => '<i class="material-icons ju-settings-icon success-color">check_circle</i>',
    'alert' => '<i class="material-icons ju-settings-icon alert-color">info</i>',
    'info' => '<i class="material-icons ju-settings-icon info-color">notification_important</i>'
);

JFactory::getDocument()->addScriptDeclaration("
    var icon = {
    'ok' : '<i class=\"material-icons ju-settings-icon success-color\">check_circle</i>',
    'alert' : '<i class=\"material-icons ju-settings-icon alert-color\">info</i>',
    'info' : '<i class=\"material-icons ju-settings-icon info-color\">notification_important</i>'
    }
");


$apache = array(
    array(
        'id' => 'mod_expires',
        'title' => JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_MOD_EXPIRES'),
        'tooltip' => JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_MOD_EXPIRES_TOOLTIP')
    ),
    array(
        'id' => 'gzip',
        'title' => Jtext::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_GZIP_ACTIVE'),
        'tooltip' => Jtext::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_GZIP_ACTIVE_TOOLTIP')
    ),
    array(
        'id' => 'mod_headers',
        'title' => Jtext::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_MOD_HEADERS'),
        'tooltip' => Jtext::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_MOD_HEADERS_TOOLTIP')
    )
);

$other = array(
    array(
        'id' => 'curl',
        'title' => JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_CURL'),
        'tooltip' => JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_CURL_TOOLTIP')
    ),
    array(
        'id' => 'openssl',
        'title' => JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_OPENSSL'),
        'tooltip' => JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_OPENSSL_TOOLTIP')
    )
);
?>
<script>
    jQuery('document').ready(function ($) {
        var check_apache_module = function () {
            $.ajax({
                url: 'index.php?option=com_speedcache&task=wizard.check_apache_modules&<?php echo JSession::getFormToken(); ?>=1',
                method: 'POST',
                success: function (res) {
                    data = JSON.parse(res);
                    if (data) {
                        $.each(data, function ($k, $v) {
                            if ($v) {
                                $('.apache-block span.notification-icon.' + $k).html(icon.ok);
                            } else {
                                if ($k === 'mod_expires') {
                                    $('.apache-block span.notification-icon.' + $k).html(icon.alert);
                                } else {
                                    $('.apache-block span.notification-icon.' + $k).html(icon.info);
                                }
                                $('.apache-block p.notification.' + $k).show(1000);
                            }
                        });
                    }
                }
            });
        };
        check_apache_module();

    });
</script>
<div class="configuration-header">
    <div class="configuration-title"><?php echo JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_TITLE') ?></div>
    <p>
        <?php echo JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_INTRODUCTION') ?>
    </p>
</div>
<div class="configuration-section margin-tb-default">
    <div class="version-block padding-tb-default">
        <label class="label-block"><?php echo JText::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_PHP_VERSION_TITLE') ?></label>
        <ul class="field">
            <li class="ju-settings-option full-width">
                <label class="ju-setting-label">
                    <?php echo Jtext::sprintf('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_PHP_VERSION_LABEL', PHP_VERSION) ?>
                </label>
                <?php
                if (version_compare(PHP_VERSION, '7.2.0', '>=')) {
                    echo $icon['ok'];
                } elseif (version_compare(PHP_VERSION, '7.2.0', '<') &&
                    version_compare(PHP_VERSION, '7.0.0', '>=')) {
                    echo $icon['info'];
                } else {
                    echo $icon['alert'];
                }
                ?>
            </li>
        </ul>
        <div class="clear"></div>
        <p class="tooltip-block">
            <?php
            if (version_compare(PHP_VERSION, '7.2.0', '<')) {
                echo Jtext::sprintf('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_PHP_VERSION_DESCRIPTION', PHP_VERSION);
            } else {
                echo Jtext::sprintf('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_PHP_VERSION_DESCRIPTION_SUCCESS', PHP_VERSION);
            }
            ?>
        </p>
        <div class="clear"></div>
    </div>
    <div class="apache-block padding-tb-default">
        <label class="label-block"><?php echo Jtext::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_APACHE_MODULES_TITLE') ?></label>
        <ul class="field">
            <?php foreach ($apache as $v) : ?>
                <li class="ju-settings-option full-width">
                    <label for="<?php echo $v['id'] ?>" class="ju-setting-label system-check-label">
                        <?php echo $v['title'] ?>
                    </label>
                    <span class="<?php echo $v['id'] ?> notification-icon"><?php echo $gif_image; ?></span>
                </li>
                <p class="<?php echo $v['id'] ?> tooltip-block notification" style="display: none"><?php echo $v['tooltip']; ?></p>
            <?php endforeach; ?>
        </ul>
        <div class="clear"></div>
    </div>

    <div class="other-block padding-tb-default">
        <label class="label-block"><?php echo Jtext::_('COM_SPEEDCACHE_WIZARD_ENVIRONMENT_OTHER_CHECK_TITLE') ?></label>
        <ul class="field">
            <?php foreach ($other as $v) :
                $checkother = false;
                // Php modules
                if (function_exists('get_loaded_extensions')) {
                    $phpModules = get_loaded_extensions();
                    if (in_array($v['id'], $phpModules)) {
                        $checkother = true;
                    }
                } else {
                    if (isset($this->php_info[$v['id']])) {
                        $checkother = true;
                    }
                }
                ?>
                <li class="ju-settings-option full-width">
                    <label for="<?php echo $v['id'] ?>" class="ju-setting-label"><?php echo $v['title'] ?></label>
                    <?php echo ($checkother) ? $icon['ok'] : $icon['alert']; ?>
                </li>
                <?php if (!$checkother) : ?>
                <p class="tooltip-block"><?php echo $v['tooltip']; ?></p>
            <?php endif; ?>
            <?php endforeach; ?>
            <!-- ---------- -->
        </ul>
        <div class="clear"></div>
    </div>
</div>
<div class="default-submit full-width">
    <button type="submit" onclick="Joomla.submitbutton('wizard.configuration_quick');"
            class="wz-button orange-button margin-auto">
        <?php echo JText::_('COM_SPEEDCACHE_WIZARD_CONTINUE_BUTTON') ?>
    </button>
</div>
