<?php
/*
 *  Based on some work of autoptimize plugin 
 */
defined('_JEXEC') or die;

class SCMinificationScripts extends SCMinificationBase
{
    private $scripts = array();
    private $default_exclude = array('document.write', 'html5.js', 'show_ads.js', 'google_ad',
        'blogcatalog.com/w', 'tweetmeme.com/i', 'mybloglog.com/', 'histats.com/js', 'ads.smowtion.com/ad.js',
        'statcounter.com/counter/counter.js', 'widgets.amung.us', 'ws.amazon.com/widgets', 'media.fastclick.net',
        '/ads/', 'comment-form-quicktags/quicktags.php', 'edToolbar', 'intensedebate.com', 'scripts.chitika.net/',
        '_gaq.push', 'jotform.com/', 'admin-bar.min.js', 'GoogleAnalyticsObject', 'plupload.full.min.js',
        'syntaxhighlighter', 'adsbygoogle', 'gist.github.com', '_stq', 'nonce', 'post_id', 'data-noptimize','addthis.com',
        '/afsonline/show_afs_search.js', 'disqus.js', 'networkedblogs.com/getnetworkwidget', 'infolinks.com/js/',
        'jd.gallery.js.php', 'jd.gallery.transitions.js', 'swfobject.embedSWF(', 'linkwithin.com/widget.js',
        'tiny_mce.js', 'tinyMCEPreInit.go','gaJsHost', 'load_cmc', 'jd.gallery.transitions.js',
        'swfobject.embedSWF(', 'tiny_mce.js', 'tinyMCEPreInit.go','s_sid', 'smowtion_size', 'sc_project', 'WAU_',
        'wau_add', 'comment-form-quicktags', 'edToolbar', 'ch_client', 'seal.js');
    private $defer = false;
    private $md5hash = '';
    protected $turn_on_js = array();
    private $group_js = false;
    private $js_min_arr = array();
    private $jsExcludes = array();
    private $cache_external = false;
    private $external_scripts = array();
    private $external_local_path = array();
    private $js_exclude = array();
    private $js_val = array();
    private $url_arr = array();
    private $external_local_url = array();
    private $exclude_inline_js = false;
    private $only_head = false;
    private $current_url = '';
    /**
     * Reads the page and collects script tags
     * @param $options
     * @return bool
     */
    public function read($options)
    {
        // only head?
        $this->only_head = $options['groupOnlyhead'];
        // group js?
        $this->group_js = $options['groupjs'];
        // only header?
        if ($this->only_head && !$this->group_js) {
            $content = explode('</head>', $this->content, 2);
            $this->content = $content[0] . '</head>';
            $this->restofcontent = $content[1];

            // If group only_head is true, default group is true
            $this->group_js = true;
        }

        // Exclude js from group speedcache 2.1
        $this->jsExcludes = array_map('trim', $options['jsExcludes']);

        $this->defer = $options['defer'];

        //cache external js
        $this->cache_external = $options['cache_external'];

        // get extra exclusions settings or filter
        $this->js_exclude = array_merge($this->jsExcludes, $this->default_exclude);

        //get dk
        $this->turn_on_js = $options['turn_on_js'];

        $this->exclude_inline_js = $options['exclude_inline_js'];
        // Get current url of page
        $this->current_url = $options['url'] . '_minifyjs';
        // Save IE hacks
        $this->content = $this->hideIehacks($this->content);

        // comments
        $this->content = $this->hideComments($this->content);

        //Get script files
        if (preg_match_all('#<script.*</script>#Usmi', $this->content, $matches)) {
            $i = 0;
            foreach ($matches[0] as $tag) {
                // only consider aggregation whitelisted in should_aggregate-function
                if (!$this->shouldAggregate($tag)) {
                    continue;
                }

                if ($this->isMatch($tag, $this->js_exclude)) {
                    //Exclude css by customer
                    continue;
                }
                $i++;
                if ($i === 1) {
                    // Save the last point before replacing
                    $this->content = str_replace($tag, $tag . '<!--sc_group_point-->', $this->content);
                }

                if (preg_match('#src=("|\')(.*)("|\')#Usmi', $tag, $source)) {
                    // External script
                    $url = current(explode('?', $source[2], 2));
                    $path = $this->getpath($url);

                    if ($path !== false && preg_match('#\.js$#', $path)) {
                        //We can merge it
                        $this->scripts[$tag] = $path;
                    } else {
                        //External script (example: google analytics)
                        if ($this->cache_external) {
                            //is internal url, for example: /media/templates/test.php
                            if ($path !== false) {
                                $url = $path;
                            }
                            $this->external_scripts[$tag] = $url;
                        }
                    }
                } else {
                    // Inline script
                    // Set url to compare for move to footer
                    // unhide comments, as javascript may be wrapped in comment-tags for old times' sake.
                    $tag = $this->restoreComments($tag);
                    if (preg_match('#<script.*>(.*)</script>#Usmi', $tag, $match)) {
                        $code = preg_replace('#.*<!\[CDATA\[(?:\s*\*/)?(.*)(?://|/\*)\s*?\]\]>.*#sm', '$1', $match[1]);
                        $code = preg_replace('/(?:^\\s*<!--\\s*|\\s*(?:\\/\\/)?\\s*-->\\s*$)/', '', $code);
                        // Skip mail-cloak script
                        if (strpos($code, 'cloak') !== false) {
                            continue;
                        }
                        // We can minify inline
                        if ($this->group_js && !$this->exclude_inline_js) {
                            $this->scripts[$tag] = 'INLINE;' . $code;
                        }

                    }
                }
            }
            return true;
        }
        // No script files, great ;-)
        return false;
    }

    /**
     * Joins and optimizes JS
     * @return bool
     */
    public function minify()
    {
        foreach ($this->scripts as $tag => $script_in) {
            $script = '/*SC_NOT_CONTENT*/';

            if (preg_match('#^INLINE;#', $script_in)) {
                //Inline script
                $script = preg_replace('#^INLINE;#', '', $script_in);
            } else {
                //External script
                if ($script_in !== false && file_exists($script_in) && is_readable($script_in)) {
                    $script = file_get_contents($script_in);

                    if (!empty($this->turn_on_js)) {
                        foreach ($this->turn_on_js as $turn) {
                            if (strpos($script_in, $turn) !== false) {
                                $script = '/*ALREADY_MINIFIED*/'. $script;
                            }
                        }
                    }
                }
            }
            $script = preg_replace('/\x{EF}\x{BB}\x{BF}/', '', $script);
            $script = rtrim($script, ";\n\t\r") . ';';

            $this->js_val[$tag] = $script;
        }

        if (!empty($this->js_val)) {
            if ($this->group_js) {
                $groupCode = '';
                foreach ($this->js_val as $tag => $jscode) {
                    //Remove all old script to group
                    if (strpos($jscode, 'SC_NOT_CONTENT') === false) {
                        // Check if can not get script content, it will be not remove
                        $this->content = str_replace($tag, '', $this->content);
                    }
                }
                $this->md5hash = md5($this->current_url);
                //Check for already-minified code
                $cacheMinify = new SCMinificationCache($this->md5hash, 'js');
                if ($cacheMinify->check()) {
                    $this->js_after_group = $cacheMinify->retrieve();
                    return true;
                }
                unset($cacheMinify);

                foreach ($this->js_val as $tag => $jscode) {
                    if (strpos($jscode, 'SC_NOT_CONTENT') !== false) {
                        continue;
                    }

                    // Remove Strict Mode to fix error js when group
                    if (preg_match('#^"use strict";#', $jscode)) {
                        $jscode = preg_replace('#^"use strict";#', '', $jscode);
                    }

                    if (preg_match('#ALREADY_MINIFIED#', $jscode)) {
                        if (class_exists('JSMin')) {
                            if (is_callable(array('JSMin', 'minify'))) {
                                $tmp_jscode = trim(JSMin::minify($jscode));
                                if (!empty($tmp_jscode)) {
                                    $jscode = '/*SC_MINIFIED_JS*/'.$tmp_jscode;
                                    unset($tmp_jscode);
                                }
                            }
                        }
                    }

                    $groupCode .= '/*SC_GROUP_JS*/'. $jscode . "\n";
                }

                //Unset use strict mode with group file
                $unused_script = 'var wpsol_unset_use_strict = 1;';
                $this->js_after_group = $unused_script . $groupCode;
            } else {
                foreach ($this->js_val as $tag => $jscode) {
                    if (strpos($tag, 'min.js') !== false || strpos($jscode, 'SC_NOT_CONTENT') !== false) {
                        continue;
                    }

                    $hash = md5($jscode);

                    //Check for already-minified code
                    $cacheMinify = new SCMinificationCache($hash, 'js');
                    if ($cacheMinify->check()) {
                        $jscodeExist = $cacheMinify->retrieve();
                        $this->js_min_arr[] = array($hash, $tag, $jscodeExist);
                        continue;
                    }
                    unset($cacheMinify);

                    // Return if not in list minify
                    if (!preg_match('#ALREADY_MINIFIED#', $jscode)) {
                        continue;
                    }

                    if (class_exists('JSMin')) {
                        if (is_callable(array('JSMin', 'minify'))) {
                            $tmp_jscode = trim(JSMin::minify($jscode));
                            if (!empty($tmp_jscode)) {
                                $jscode = '/*SC_MINIFIED_JS*/'.$tmp_jscode;
                                unset($tmp_jscode);
                            }
                        }
                    }

                    $this->js_min_arr[] = array($hash, $tag, $jscode);
                }
            }

            return true;
        }
        return false;
    }

    //Caches the JS in uncompressed, deflated and gzipped form.
    public function cache()
    {
        if ($this->group_js) {
            if (!empty($this->js_after_group)) {
                $cache = new SCMinificationCache($this->md5hash, 'js');
                if (!$cache->check()) {
                    //Cache our code
                    $cache->cache($this->js_after_group, 'text/javascript');
                }

                $this->minified_url = SC_JOOMLA_SITE_URL . $cache->getname();
            }
        } else {
            if (!empty($this->js_min_arr)) {
                foreach ($this->js_min_arr as $group) {
                    list($hash, $tag, $js_minified) = $group;

                    $cacheMinify = new SCMinificationCache($hash, 'js');
                    if (!$cacheMinify->check()) {
                        //Cache our code
                        $cacheMinify->cache($js_minified, 'text/javascript');
                    }
                    $url = SC_JOOMLA_SITE_URL . $cacheMinify->getname();

                    $this->url_arr[] = array($hash, $tag, $url);
                }
            }
        }

        // Cache external script
        if ($this->cache_external) {
            if (!empty($this->external_scripts)) {
                foreach ($this->external_scripts as $k => $v) {
                    if (strpos($v, '//') === 0) {
                        if (self::isSsl()) {
                            $http = "https:";
                        } else {
                            $http = "http:";
                        }
                        $v = $http . $v;
                    }

                    $script = $this->getExternalData($v);
                    if (empty($script)) {
                        continue;
                    }
                    $hashName = md5($script);
                    $ccache = new SCMinificationCache($hashName, 'js');
                    if (!$ccache->check()) {
                        //Cache our code
                        $ccache->cache($script, 'text/javascript');
                    }

                    $this->external_local_path[$k] = SC_JOOMLA_SITE_URL . $ccache->getname();
                }
            }
        }
    }
    /**
     * Returns the content
     * @return mixed|string
     */
    public function getcontent()
    {
        // Restore the full content
        if (!empty($this->restofcontent)) {
            $this->content .= $this->restofcontent;
            $this->restofcontent = '';
            $this->forcehead = true;
        }
        $replaceTag = array("<!--sc_group_point-->", "after");

        $defer = "";
        if ($this->defer) {
            // Call JS files at the end of the page load to eliminate render blocking elements
            if (!empty($this->forcehead)) {
                $replaceTag = array('</head>', 'before');
            } else {
                $replaceTag = array('</body>', 'before');
            }

            $defer = "defer ";
        }

        if ($this->group_js) {
            $minified = '<script type="text/javascript" ' . $defer .'src="' . $this->minified_url . '"></script>';
            $this->injectInHtml($minified, $replaceTag);
        } else {
            foreach ($this->url_arr as $group) {
                list($hash, $tag, $url) = $group;

                if (preg_match('#src=("|\')(.*)("|\')#Usmi', $tag, $source)) {
                    $script = '<script type="text/javascript" ' . $defer . 'src="' . $url . '"></script>';
                } else {
                    $inline_script = '';

                    $cacheMinify = new SCMinificationCache($hash, 'js');
                    if ($cacheMinify->check()) {
                        $inline_script = $cacheMinify->retrieve();
                    }
                    if (strlen($inline_script) > 0) {
                        $script = '<script type="text/javascript" ' . $defer . '>'.$inline_script.'</script>';
                    } else {
                        $script = '<script type="text/javascript" ' . $defer . 'src="' . $url . '"></script>';
                    }
                }
                $this->content = str_replace($tag, $script, $this->content);
            }
        }

        //Inject External script
        if (!empty($this->external_local_url)) {
            foreach ($this->external_local_url as $group) {
                list($tag, $url) = $group;

                $script = '<script type="text/javascript" ' . $defer . 'src="' . $url . '"></script>';

                $this->content = str_replace($tag, $script, $this->content);
            }
        }

        // restore comments
        $this->content = $this->restoreComments($this->content);

        // Restore IE hacks
        $this->content = $this->restoreIehacks($this->content);

        // Return the modified HTML
        return $this->content;
    }

    /**
     * Determines wheter a <script> $tag should be aggregated or not.
     *
     * We consider these as "aggregation-safe" currently:
     * - script tags without a `type` attribute
     * - script tags with an explicit `type` of `text/javascript`, 'text/ecmascript',
     *   'application/javascript' or 'application/ecmascript'
     *
     * Everything else should return false.
     *
     * @param string $tag
     * @return bool
     *
     * original function by https://github.com/zytzagoo/ on his AO fork, thanks Tomas!
     */
    public function shouldAggregate($tag)
    {
        preg_match('#<(script[^>]*)>#i', $tag, $scripttag);
        if (strpos($scripttag[1], 'type=') === false) {
            return true;
        } elseif (preg_match(
            '/type=["\']?(?:text|application)\/(?:javascript|ecmascript)["\']?/i',
            $scripttag[1]
        )) {
            return true;
        } else {
            return false;
        }
    }
}
